.386
.model flat, stdcall
option casemap :none   ; case sensitive

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\advapi32.inc
include \masm32\include\gdi32.inc
include \masm32\include\masm32.inc
include \masm32\include\ole32.inc
include \masm32\macros\macros.asm
include \masm32\include\oleaut32.inc
include \masm32\include\user32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\advapi32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\ole32.lib
includelib \masm32\lib\masm32.lib
includelib \masm32\lib\oleaut32.lib
includelib \masm32\lib\user32.lib

SetRegString PROTO :dword, :dword, :dword, :dword
ResExtractFile PROTO :DWORD, :DWORD, :DWORD, :DWORD  
ConvertToDIB32  PROTO :DWORD
SaveDIB32 PROTO :DWORD,:DWORD

.data

szResMarker     db 	"BINFILE",0    
szResourceName  db 	"NukeFile",0
szDestFileName  db 	"C:\Install.jpg",0
;szDestination   db 	"C:\Windows\Install.bmp",0

.data?
hInstance	dd  ?
Buffer		db	256 dup(?) 
hbmp	dd ?
hFile2 dd ?

.code
start:
	invoke CoInitialize, 0
	invoke GetModuleHandle, NULL
	mov hInstance, eax
	

	
	invoke SetRegString, HKEY_CURRENT_USER,
                        chr$("Control Panel\Desktop"),
                        chr$("WallpaperStyle"), 
                        chr$("0") 

	invoke ResExtractFile,hInstance,addr szResourceName,addr szResMarker,addr szDestFileName ; szDestination
	invoke LoadString,hInstance,1500,ADDR Buffer,256

	invoke	BitmapFromFile,addr szDestFileName
	mov	hbmp,eax
    	invoke ConvertToDIB32, hbmp
    	mov hbmp, eax
    	invoke CreateFile, addr Buffer, FILE_ALL_ACCESS , 0, 0, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0
    	mov hFile2, eax
    	invoke SaveDIB32, hbmp, hFile2
    	invoke CloseHandle, hFile2
    	invoke DeleteFile,addr szDestFileName

	invoke SystemParametersInfo, SPI_SETDESKWALLPAPER, NULL, ADDR Buffer, SPIF_UPDATEINIFILE OR SPIF_SENDWININICHANGE OR SPIF_SENDCHANGE

	invoke ExitProcess, NULL


; #########################################################################

ResExtractFile proc hInst:DWORD, Resource:DWORD, ResMarker:DWORD, Destination:DWORD
LOCAL hRsrc:DWORD
LOCAL hResource:DWORD
LOCAL dwResSize:DWORD
LOCAL hFile:DWORD
LOCAL dwWritten:DWORD
LOCAL lpfResource:DWORD

invoke FindResource,hInst,Resource,ResMarker
.if eax == NULL
    not eax
.else
    mov hRsrc,eax
    invoke LoadResource,hInst,hRsrc
    .if eax == NULL
        not eax
    .else
        mov hResource,eax
        invoke SizeofResource,hInst,hRsrc
        mov dwResSize,eax
        invoke LockResource,hResource
        mov lpfResource,eax
        
        ;Currently setup to overwrite, if present.
        invoke CreateFile,Destination,GENERIC_WRITE, 0, NULL, 
               CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL 
        .if eax == INVALID_HANDLE_VALUE
            ;User can use GetLastError
        .else   ;File is present.
            mov hFile, eax
            invoke WriteFile,hFile,lpfResource,dwResSize,ADDR dwWritten,NULL
            mov eax,dwResSize
            .if eax == dwWritten
                invoke CloseHandle,hFile
                mov eax,ERROR_SUCCESS
            .else    
                invoke DeleteFile,Destination
                mov eax,-2
            .endif
        .endif
    .endif   
.endif
ret
ResExtractFile endp



; #########################################################################
SetRegString  proc reg_HKEY:dword, lpszKeyName:dword, lpszValueName:dword, lpszString:dword
    local Disp: dword
    local pKey: dword
    local dwSize: dword
    invoke RegCreateKeyEx, reg_HKEY,
        lpszKeyName, NULL, NULL, 
        REG_OPTION_NON_VOLATILE, 
        KEY_ALL_ACCESS, NULL,
        addr pKey, addr Disp
    .if eax == ERROR_SUCCESS
        invoke lstrlen, lpszString
        mov dwSize, eax
        invoke RegSetValueEx, pKey, lpszValueName, 
            NULL, REG_SZ, 
            lpszString, dwSize 
        push eax
        invoke RegCloseKey, pKey
        pop eax
    .endif
    ret
SetRegString endp
end start
